function y = forward_euler1(x0, y0, f, h)
  % Compute one iteration of the forward Euler method.
  %
  % INPUT:
  %
  %   * ``x0`` - The initial x-coordinate.
  %
  %   * ``y0`` - The initial value y(x0).
  %
  %   * ``f`` - The function y' = f(x,y) of two variables.
  %
  %   * ``h`` - The step size.
  %
  % OUTPUT:
  %
  % The approximate value of y(x) at x = x0+h.
  %
  y_prime = f(x0,y0);
  y = y0 +  h * y_prime;
end
